#include <reg251s.h>              /* special function register declarations   */
                                  /* for the intended 80251 derivative        */

#include <stdio.h>                /* prototype declarations for I/O functions */

extern void bank1 (void);         /* function will be called with ECALL       */

static void near_func (void)  {   /* C251 will generate LCALL to static funcs */
  printf ("This is a near function in module main\n");
}

/****************/
/* main program */
/****************/
void main (void)  {               /* execution starts here after stack init   */
#ifndef MCB251
  SCON  = 0x50;                   /* SCON: mode 1, 8-bit UART, enable rcvr    */
  TMOD |= 0x20;                   /* TMOD: timer 1, mode 2, 8-bit reload      */
  TH1   = 0xf3;                   /* TH1:  reload value for 2400 baud         */
  TR1   = 1;                      /* TR1:  timer 1 run                        */
  TI    = 1;                      /* TI:   set TI to send first char of UART  */
#endif

  printf ("This is the main function\n");
  near_func ();                   /* LCALL in same module to static function  */
  bank1 ();                       /* ECALL to function in different module    */
  printf ("Bank in main function\n");
}
